<?
/*--------------------------------------------------------------------
   KorWeblog :: Highly Customizable Weblog/CMS
   Copyright (C) 2001-2004 by Im Eunjea <eunjea@kldp.org>
   For detail of license and/or other info, see the file doc/COPYING.
   http://weblog.kldp.org
----------------------------------------------------------------------

LICENSE

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
----------------------------------------------------------------------*/

/* Based on <http://jsboard.kldp.org> */
function KWL_GetAgent() {
   $agent_env = $_SERVER['HTTP_USER_AGENT'];
   
   if(ereg("MSIE", $agent_env)) {
      $agent['br'] = "MSIE";
      if(ereg("NT", $agent_env)) {
         $agent['os'] = "NT";
      } else if(ereg("Win", $agent_env)) {
         $agent['os'] = "WIN";
      } else $agent['os'] = "OTHER";
   } else if(ereg("^Mozilla", $agent_env)) {
      if(preg_match("/gecko|galeon/i",$agent_env)) $agent['br'] = "MOZL6";
      else $agent['br'] = "MOZL";
      if(ereg("NT", $agent_env)) {
         $agent['os'] = "NT";
         if(ereg("\[ko\]", $agent_env)) $agent['ln'] = "KO";
      } else if(ereg("Win", $agent_env)) {
         $agent['os'] = "WIN";
         if(ereg("\[ko\]", $agent_env)) $agent['ln'] = "KO";
      } else if(ereg("Linux", $agent_env)) {
         $agent['os'] = "LINUX";
         if(ereg("\[ko\]", $agent_env)) $agent['ln'] = "KO";
      } else $agent['os'] = "OTHER";
   } else if(preg_match("/lynx|w3m|links/i", $agent_env)) {
      $agent['br'] = "TXT";
   } else if(ereg("Konqueror",$agent_env)) {
      $agent['br'] = "KONQ";
   } else $agent['br'] = "OTHER";
   if (empty($agent['ln'])) $agent['ln'] = '';
   return $agent;
}

/* Based on <http://jsboard.kldp.org> */
function KWL_FormSize($size,$print=0) {
   global $agent;
   $langs = KWL_GetConf('Language');

   if($agent['br'] == "MOZL") {
      if($agent['os'] == "NT") {
         if($agent['ln'] == "KO") $size *= 1.1;
         else {
            if ($langs == "korean") $size *= 2.6;
            else $size *= 1.4;
         }
      } else if($agent['os'] == "WIN") {
         if($agent['ln'] == "KO") $size *= 1.1;
         else $size *= 1.3;
      } elseif($agent['os'] == "LINUX") $size *= 1.8;
   }

   if($agent['br'] == "MOZL6") {
      if($agent['os'] == "NT") {
         if($agent['ln'] == "KO") $size *= 1.1;
         else {
            if ($langs == "korean") $size *= 2.3;
            else $size *= 1.8;
         }
      } else $size *= 1.8;
   }
   
   if($agent['br'] == "MSIE") {
      if ($agent['os'] == "NT")
         if ($langs == "korean") $size *= 2.3;
         else $size *= 2.0;
      else $size *= 2.3;
   }
   if($agent['br'] == "TXT") $size *= 2;
   if($agent['br'] == "KONQ") $size *= 2.6;
   $size = intval($size);
   if($print) echo $size;
   return $size;
}

/* class for check page precessing time */
class KWL_Process_Time {
   function timer($name) {
      $microtime = explode(' ', microtime());
      $this->markers[$name] = $microtime[1] . substr($microtime[0], 1);
   }
   function bench_result($start = 'start', $end = 'stop') {
      return sprintf("%.2f" , $this->markers[$end] - $this->markers[$start]);
   }
}

function KWL_FileUpload($file,$path,$updir,$maxsize) {
	global $exec;

	if (!is_uploaded_file($file['tmp_name'])) return;
	if ($file['size'] > $maxsize) KWL_ShowError(_FILE_TOOBIG);
	else if (!$file['size']) KWL_ShowError(_UPLOAD_FAILED);

	$file['name'] = eregi_replace(" ","",$file['name']);
	KWL_CheckFileName($file['name']);

	$file['name'] = eregi_replace("[.]*$","",$file['name']);
	$file['name'] = eregi_replace(".(ph|inc|php[0-9a-z]*|phtml)$",".phps",$file['name']);
	$file['name'] = eregi_replace("(.*)\.(cgi|pl|sh|html|htm|shtml|vbs)$", "\\1_\\2.phps", $file['name']);

	if (!file_exists($path)) @mkdir($path,0755);
	@mkdir($path .'/'. $updir,0755);
	@move_uploaded_file($file['tmp_name'], $path .'/'. $updir .'/'. $file['name']);
	@chmod($path .'/'. $updir .'/'. $file['name'],0644);
	if (!file_exists("$path/index.html")) KWL_WriteFile("$path/index.html",";-)");
   return $file;
}

function KWL_filetype_check($filetype) {
	$tail = substr( strrchr($filetype, "."), 1 );
	$tail = strtolower($tail);
	return $tail;
}

function KWL_icon_check($bofile) {

	$t = KWL_filetype_check($bofile);

	if (eregi("^(hwp|mov|txt)$",$t)) $icon = "$t.gif";
	else if (eregi("^(exe|com)$",$t)) $icon = "exe.gif";
	else if (eregi("^(zip|arj|gz|lha|rar|tar|tgz|ace)$",$t)) $icon = "comp.gif";
	else if (eregi("^(php|php3|phps|vbs)$",$t)) {
		if (eregi("(_htm|_cgi|_pl|_shtm|_sh)",$bofile)) $icon = "html.gif";
		else $icon = "php.gif";
	} else if (eregi("^(avi|mpg|mpeg|asf|swf)$",$t)) $icon = "mpeg.gif";
	else if (eregi("^(jpg|gif|bmp|psd|png)$",$t)) $icon = "pic.gif";
	else if (eregi("^(ppt|xls|doc)$",$t)) $icon = "doc.gif";
	else if (eregi("^(ra|ram|rm)$",$t)) $icon = "ra.gif";
	else if (eregi("^(mp3|mp2|wav|mid)$",$t)) $icon = "mp3.gif";
	else $icon = "file.gif";

	$tmp = "<img src=\"". KWL_GetConf('G_URL') ."/images.d/icon/$icon\" border=\"0\" alt=\"$bofile\" align=\"middle\" />";

	return $tmp;
}

function KWL_file_view($topic,$bcfile,$bofile) {
   $CONF = KWL_GetConf();

	$tail = KWL_filetype_check($bofile);
	$upload_file = "upload/$topic/$bcfile/$bofile" ;

	if (($tail == "gif" || $tail == "jpg" || $tail == "jpeg" || $tail == "png"))
	{

	$image_size = @GetImageSize("$CONF[G_PATH]/$upload_file");
   if ($CONF['thumbnail'] && ($image_size[0] > $CONF['thumbx'] || $image_size[1] > $CONF['thumby'])) {

      $tmp = "<br />\n<center>[ ". _VIEW_ORIG_FILE ." $image_size[0] x $image_size[1] ]<br />".
         "<a href=\"$CONF[G_URL]/$upload_file\" target=\"_blank\">";

      /* make thumbnail */      
      if (!file_exists("$CONF[G_PATH]/$upload_file"."_t.jpg")) {
         if (file_exists($CONF['imagick'])) {
            @exec($CONF['imagick'] ." -geometry $CONF[thumb_size] \"$CONF[G_PATH]/$upload_file\" \"$CONF[G_PATH]/$upload_file"."_t.jpg\"");
            @chmod("$CONF[G_PATH]/$upload_file"."_t.jpg",0644);
         }
      }
      
      if (file_exists("$CONF[G_PATH]/$upload_file"."_t.jpg")) {
         
         $tmp .= "<img src=\"$CONF[G_URL]/$upload_file"."_t.jpg\" vspace=\"0\" hspace=\"0\" title=\""._VIEW_ORIG_FILE."\" alt=\""._VIEW_ORIG_FILE."\" border=\"0\" />";
         
      } else {

         if (extension_loaded("gd")) {

            $tmp .= "<img src=\"$CONF[G_URL]/img.php?url=". rawurlencode($upload_file) ."\" width=\"{$CONF['thumb_size']}\" height=\"". intval($image_size[1]/($image_size[0]/$CONF['thumb_size'])) ."\" vspace=\"0\" hspace=\"0\" title=\""._VIEW_ORIG_FILE."\" alt=\""._VIEW_ORIG_FILE."\" border=\"0\" />";

         } else {

            $tmp .= "<img src=\"$CONF[G_URL]/$upload_file\" width=\"{$CONF['thumb_size']}\" height=\"". intval($image_size[1]/($image_size[0]/$CONF['thumb_size'])) ."\" vspace=\"0\" hspace=\"0\" title=\""._VIEW_ORIG_FILE."\" alt=\""._VIEW_ORIG_FILE."\" border=\"0\" />";

         }
         
      }

      $tmp .= "</a></center><br />\n";

   } else {
      $tmp = "<br />\n<center>[Image Size $image_size[0] x $image_size[1]]<br /><img src=\"$CONF[G_URL]/$upload_file\" $image_size[3] vspace=\"0\" hspace=\"0\" alt=\"$bofile\" border=\"0\" /></center><br />\n";
   }

	} else if (($tail == "phps" || $tail == "txt" || $tail == "htmls" || $tail == "htm" || $tail == "shs")) {

	$view = KWL_ReadFile("$CONF[G_PATH]/$upload_file");
	$tmp = "<p />\n ---------------- " . _ATTCHED_FILE . " ----------------\n<p /><pre>\n";
	$tmp .= htmlspecialchars($view);
	$tmp .= "\n</pre>\n";
	$tmp .= "\n------------------------------------------\n";
  } else $tmp = "";

return $tmp;
}

/* Based on <http://jsboard.kldp.org> */
function KWL_FileHSize($size, $sub=0) {
   $bytes = number_format($size) . " Bytes";
   if($size < 1024) return $bytes;
   else if($size < 1048576)
      $size = number_format(round($size/1024)) ." KiB";
   else if($size < 1073741827)
      $size = number_format(round($size/1048576)) ." MiB";
   else
      $size = number_format(round($size/1073741827)) ." GiB";
   if ($sub) $size .= "($bytes)";
   return $size;
}

/* Based on http://jsboard.kldp.org */
function KWL_UnHtmlSpecialchars($t) {
	$tr = array_flip(get_html_translation_table(HTML_SPECIALCHARS));
	$t = strtr(str_replace("&#039;","'",$t),$tr);
	$t = strtr(str_replace("&amp;","&",$t),$tr);

	return $t;
}

/* Based on http://jsboard.kldp.org */
function KWL_CheckHangul($char) {
  # Ư ڰ ѱ (0xA1A1 - 0xFEFE) ִ ˻
  $char = ord($char);

  if($char >= 0xa1 && $char <= 0xfe)
    return 1;
}

function KWL_CheckAlpha($char) {
  $char = ord($char);

  if($char >= 0x61 && $char <= 0x7a)
    return 1;
  if($char >= 0x41 && $char <= 0x5a)
    return 2;
}

/* Based on http://jsboard.kldp.org */
function KWL_UrlCheck($url) {
	$url = trim($url);

	if(!eregi("^(http://|https://|ftp://|telnet://|news://)", $url))
		$url = eregi_replace("^", "http://", $url);

	if(!eregi("(http|https|ftp|telnet|news):\/\/[\xA1-\xFEa-z0-9-]+\.[][\xA1-\xFEa-zA-Z0-9,:&#@=_~%?\/.+-]+$", $url))
	return;

	return $url;
}

/* Based on http://jsboard.kldp.org */
function KWL_EmailCheck($email) {
	$email = trim($email);
	if(eregi("^[\xA1-\xFEa-z0-9_-]+@[\xA1-\xFEa-z0-9_-]+\.[a-z0-9._-]+$", $email)) return $email;
	else return;
}

function KWL_ShowError($str,$back=1,$width=300,$height=125) {
   global $agent;
   $CONF = KWL_GetConf();

   echo "<script language=\"javascript\">\n<!--\n";
   if(preg_match("/^(WIN|NT)$/i",$agent['os']) || $agent['br'] == "MOZL6") {
      $str = wordwrap($str,50);
      $str = preg_replace("/\n/","\\n",$str);
      $str = preg_replace("/('|#|\))/","\\\\1",$str);
      echo "alert('$str');\n";
	} else {
      $tmp = urlencode($str);
      echo "var farwindow = null;\n".
           "function remoteWindow() {\n".
           "   farwindow = window.open(\"\",\"LinksRemote\",\"width=$width,height=$height,scrollbars=1,resizable=0\");\n".
           "   if (farwindow != null) {\n".
           "      if (farwindow.opener == null) { farwindow.opener = self; }\n".
           "      farwindow.location.href = \"$CONF[G_URL]/notice.php?str=$tmp\";\n".
           "   }\n".
           "}\n".
           "remoteWindow();\n";
   }
   echo "//-->\n</script>\n".
        "<noscript>$str</noscript>\n";
   if ($back) {
      echo "<script>history.back()</script>\n";
      exit;
   }
}

function KWL_SpamCheck($str,$writer,$email) {
	$CONF = KWL_GetConf();

   if (extension_loaded("mbstring")) $mbs = true;
   else $mbs = false;
   $str = $mbs ? mb_convert_encoding($str,"UTF-8") : $str;

   $anti = KWL_ReadFile("$CONF[G_PATH]/logs/spam_list.txt");
   $anti = preg_split("/(?:\r\n|\r|\n)/", $anti);

   foreach ($anti as $var) {
      if (strlen($var) < 2) continue;
      if (!$mbs && strlen($var) < 3) continue;
      if(preg_match("/^#|^$/i",trim($var))) continue;
      $var = str_replace("/","\/",$var);
      $var = $mbs ? mb_convert_encoding(trim($var),"UTF-8") : $var;
      $var = trim($var);
      if(preg_match("/$var/i", $str)) {
         KWL_SpamWarning($str,$writer,$email,1);
         KWL_ShowError(_DONT_SPAM);
      }      
   }
	return 0;
}

function KWL_PostBlockIP($str,$writer,$email) {
	$CONF = KWL_GetConf();
 	$uip = KWL_GetIP(0);

	if ($tmp = KWL_ReadFile("$CONF[G_PATH]/logs/ip_list.txt")) {
		$anti = preg_split("/(?:\r\n|\r|\n)/", $tmp);
		if (in_array($uip, $anti)) {
			KWL_SpamWarning($str,$writer,$email);
			KWL_ShowError(_BLOCK_IP);
		}
	}
}

function KWL_ProofSpam($str) {
	$CONF = KWL_GetConf();

	if ($tmp = KWL_ReadFile("$CONF[G_PATH]/logs/spam_list.txt")) {
		$anti = preg_split("/(?:\r\n|\r|\n)/", $tmp);
		
		foreach($anti as $var) {
			$var = eregi_replace("(\r|\n)","",$var);
			if (strlen($var)>2) {
				if (KWL_CheckHangul($var)) $sl = strlen($var) / 2;
				else $sl = strlen($var);
			$c = str_repeat("*",$sl);
			$str = preg_replace("/$var/i", $c , $str);
			}
		}
	}
	return $str;	
}

function KWL_BlockingIP() {
	$uip = KWL_GetIP(0);
	if ($tmp = KWL_ReadFile(KWL_GetConf("G_PATH")."/logs/block_ip.txt")) {
		$anti = preg_split("/(?:\r\n|\r|\n)/", $tmp);
		if (in_array($uip, $anti)) {
			die(_BLOCK_IP);
		}
	}
}

function FWL_CheckDuplePost($content,$author,$from) {
   $last = SqlQueryFetchArray("SELECT Author,Content FROM $from ORDER BY Birthstamp DESC");
   if (stripslashes(trim($author)) == $last['Author'] && stripslashes(trim($content)) == $last['Content']) KWL_ShowError(_SAME_POST);
}

function KWL_ReadFile($filename) {
	if (file_exists($filename)) {
		$fp = @fopen($filename,"rb");
		/* flock($fp, LOCK_SH); */
		$content = @fread($fp, filesize($filename));
		fclose($fp);
		return $content;
	} else return false;
}

function KWL_WriteFile($filename,$data) {
	if ($fp = fopen($filename,"wb")) {
		/* flock($fp, LOCK_SH); */
		fwrite($fp,$data);
		fclose($fp);
		return true;
	} else return false;
}

function KWL_GetFileName($dir,$limit='') {
   $return = array();
   if (file_exists($dir)) {
      $handle = opendir($dir);
      while ($file = readdir($handle)) {
         if ($file != "." && $file != "..") {
            if ($limit) {
               if ($limit == KWL_filetype_check($file)) $return[] = $file;
            } else {
               $return[] = $file;
            }
         }
      }
      return $return;
   }
}

function KWL_CheckFileName($name) {
	$name = trim($name);
	if (empty($name)) KWL_ShowError(_FILE_SIZE_0);
	elseif (eregi("[^\xA1-\xFEa-z0-9._\-]|\.\.",urldecode($name))) KWL_ShowError(_FILE_NAME_N);
}

function KWL_MakeMaxUploadSize($size) {
   $post_max = ini_get('post_max_size');
   $up_max = ini_get('upload_max_filesize');
   if(preg_match("/M$/i",$post_max)) {
      $post_max = (preg_replace("/M$/i","",$post_max) - 1) * 1024 * 1024;
   } elseif (preg_match("/K$/i",$post_max)) {
      $post_max = (preg_replace("/K$/i","",$post_max) - 1) * 1024;
   } else {
      $post_max -= 1024;
   }
   $ret = ($size > $post_max) ? $post_max : $size;
   return $ret;
}

function KWL_MakeTimeSelect($year='', $day='', $month='', $hour='', $min='') {
	$today	= getdate();
	$tday		= $today['mday'];
	$tmon	= $today['mon'];
	$tyear	= $today['year'];
	$thour	= $today['hours'];
	$tmin		= $today['minutes'];

	if (empty($year)) $year = $tyear;
	if (empty($day)) $day = $tday;
	if (empty($month)) $month = $tmon;
	if (empty($hour)) $hour = $thour;

	$ret = "<input type=\"text\" name=\"year\" value=\"$year\" size=\"5\" maxlength=\"4\" />" . _YEAR;

	$ret .= "<select name=\"month\">";
	for ($xmonth=1; $xmonth <= 12; $xmonth++) {
	$ret .= "<option name=\"month\" ". (($xmonth == $month) ? "selected=\"selected\"" : "") .">$xmonth</option>";
	}
	$ret .= "</select>". _UMONTH;	
	
	$ret .= "<select name=\"day\">";
	for ($xday=1; $xday <= 31; $xday++) {
		$ret .= "<option name=\"day\" ". (($xday == $day) ? "selected=\"selected\"" : "") .">$xday</option>";
	}
	$ret .= "</select>". _DAY ."&nbsp;&nbsp;";
	
	$ret .= "<select name=\"hour\">";	
	for ($xhour=0; $xhour <= 23; $xhour++) {
		$ret .= "<option name=\"hour\" ". (($xhour == $hour) ? "selected=\"selected\"" : "") .">$xhour</option>";
	}
	$ret .= "</select>". _HOUR;
	
	$ret .= "<select name=\"min\">";
	for ($xmin=0; $xmin <= 59; $xmin = $xmin+5) {
		if (($xmin == 0) OR ($xmin == 5)) $xmin = "0$xmin";
		$ret .= "<option name=\"min\" ". (($xmin == $min) ? "selected=\"selected\"" : "") .">$xmin</option>";
	}
	$ret .= "</select>". _MINUTE;
		
return $ret;
}

function KWL_CheckLocalReferer($deny=0) {

	if (empty($_SERVER['HTTP_HOST'])) $server = getenv('HTTP_HOST');
	else $server = $_SERVER['HTTP_HOST'];
	
	if (empty($_SERVER['HTTP_REFERER'])) $referer = getenv('HTTP_REFERER');
	else $referer = $_SERVER['HTTP_REFERER'];

	if ($deny && !preg_match("!^http://$server/!", $referer)) {
		KWL_AccessLog(_ACCESS_DENIED);
		die(_ACCESS_INVALID);
	} else {
		return (preg_match("!^http://$server/!", $referer));
	}
}

function KWL_Redirect($url,$fix=0,$delay=0) {
   if (!preg_match('!^http!', $url)) $url = KWL_GetConf("G_URL") ."/". $url;
   else $url = preg_replace('!^/*!', '', $url);
   
   if ($fix) {
      echo "<meta http-equiv=\"refresh\" content=\"$delay;url=$url\">";
      exit;
   } else {
      Header("Location: $url");
      exit;
   }
}

function KWL_RedirectNotice($str,$url='',$delay=0) {
   global $LAYOUT,$rdf_lang;
   $CONF = KWL_GetConf();

   list($site_name,$site_desc) = KWL_PrepareHtml($CONF['SiteName'],$CONF['SiteSlogan']);
   echo "<html>\n<head>\n"
      . "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=$rdf_lang\">\n";
   if (empty($url)) $url = $CONF['G_URL'];
   echo "<meta http-equiv=\"refresh\" content=\"$delay;URL=". htmlspecialchars($url) ."\">\n".
        "</head>\n"
      . "<body text=\"$LAYOUT[FgColor]\" bgcolor=\"$LAYOUT[BgColor]\">\n"
      . "<br><table width=\"550\" align=\"center\"><tr><td>\n";
   $A['Heading'] = "$site_name :: $site_desc";
   $A['Content'] = "<br><center><b>$str</b></center><br>";
   KWL_DrawMain($A);
	echo "</tr></td></table>\n</body>\n</html>\n";
   exit;
}


function KWL_MakeNavigator($display) {
   global $login;

   $CONF = KWL_GetConf();
   
   $rt = SqlQuery("SELECT * FROM T_Link_Order WHERE display = '$display' ORDER BY orderid ASC");
   if (!mysql_num_rows($rt)) return;
   $base = "<a class=\"nav\" href=\"$CONF[G_URL]/%s\">%s</a>";
   
   while ($A = mysql_fetch_array($rt)) {
      switch ($A['name']) {
         case "index": $ret[] = sprintf($base,"stories.php",_INDEX); break;
         case "search": $ret[] = sprintf($base,"search.php",_FIND); break;
         
         case "archive": 
            if ($CONF['Archive']) $ret[] = sprintf($base,"archive.php",_ARCHIVE);
         break;
         
         case "contrib": 
            if ($CONF['AllowContrib']) $ret[] = sprintf($base,"contrib.php?".time(),_CONTRIB);
         break;
         
         case "links":
            if ($CONF['Links']) $ret[] = sprintf($base,"links.php",_LINKS);
         break;
         
         case "poll":
            if (SqlCount("T_PollQuestions")) {
               $ret[] = sprintf($base,"pollbooth.php",_POLLS);
            }
         break;
         
         case "page": 
            $sql  = "SELECT Rid,Heading from T_Blocks WHERE Display = 'p' ORDER BY OrderID";
            $result = SqlQuery($sql);
            if (mysql_num_rows($result)) {
               while ($row = mysql_fetch_array($result)) {
                  $ret[] = "<a class=\"nav\" href=\"$CONF[G_URL]/pages.php?page=$row[Rid]\">$row[Heading]</a>";
               }
            }
         break;
         
         case "download":
            if ($CONF['download']) $ret[] = sprintf($base,"download.php",_DOWNLOAD);
         break;
         
         case "stats":
            if ($CONF['SiteStats']) $ret[] = sprintf($base,"stats.php",_STATS);
         break;
         
         case "faq": 
            if ($CONF['FAQ']) $ret[] = sprintf($base,"faq.php","FAQ");
         break;
         
         case "user":
            if (!$CONF['NoLogin_User']) {
               if ($login) $ret[] = "<a class=\"nav\" href=\"$CONF[G_URL]/user.php\">". _UHOME ."</a>";
               else $ret[] = "<a class=\"nav\" href=\"$CONF[G_URL]/login.php?location=".urlencode($_SERVER['PHP_SELF'] ."?". $_SERVER['QUERY_STRING'])."#login\">". _LOGIN ."</a>";
            }
         break;

         case "config":
            if ($CONF['NoLogin_User']) {
               $ret[] = "<a class=\"nav\" href=\"$CONF[G_URL]/config.php\">". _CONFIG ."</a>";
            }
         break;
         
         case "contact":
            if ($CONF['CONTACT']) $ret[] = "<a class=\"nav\" href=\"$CONF[G_URL]/profiles.php?Author=" . urlencode($CONF["SiteOwner"]) . "&amp;AuthorEmail=" . KWL_Rot13($CONF['EmailAddress']) . "&amp;AuthorURL=" . $CONF['G_URL'] . "\">" . _CONTACT . "</a>";
         break;

         case "external":
            $ret[] = "<a class=\"nav\" href=\"$A[url]\">$A[display_name]</a>";
         break;
      }
   }
   return $ret;
}

function KWL_SblockTitle($url,$fix=0) {
   $CONF = KWL_GetConf();
   $feature_title = KWL_GetConf("feature");
   switch ($url) {
      case "login.php": return _LOGIN; break;
      case "older.php": return _OLDER; break;
      case "theme.php": return _THEME_USE; break;
      case "topic.php": return _TOPIC; break;
      case "hot5.php": return _HOT5; break;
      case "lastc5.php": return _LASTC5; break;
      case "top5.php": return _TOP5; break;
      case "poll.php": return _POLLS; break;
      case "tb.php": return _TB_BLOCK; break;

      case "scroll.php":
         return $fix ? _SCROLL_BLOCKA : _SCROLL_BLOCK;
      break;

      case "rlink.php": 
         return $CONF['rlink_title'] ? $CONF['rlink_title'] : _RANDOM_LINK;
      break;
      
      case "rbutton.php":
         return $CONF['rbutton_title'] ? $CONF['rbutton_title'] : _RANDOM_BUTTON;
      break;

      case "feature.php":
         return $CONF['feature'] ? $CONF['feature'] : _FEATURES;
      break;
   }
}

/* checking values are not modified by user */
function KWL_HcodeCheck($str,$hcode,$w=0,$check=0) {
   $exe = $w ? 'crc32' : 'md5';
   if ($hcode == $exe($str . KWL_GetConf("SiteKey"))) return true;
   else {
      return $check ? die(_CHANGED_VARS) : false;
   }
}

function KWL_HcodeMake($str,$w=0) {
   $exe = $w ? 'crc32' : 'md5';
   return $exe($str . KWL_GetConf("SiteKey"));
}

/* checking rid values from user input */
function KWL_ValidRid($var) {
   $var = preg_replace('!^/!','',$var);
   if (ereg("^[0-9]{2}/[0-9]{2}/[0-9]{2}/[0-9]{7}",$var)) return true;
   else return false;
}

function KWL_GetPhpVersion() {
   static $php_version;

   if (!isset($php_version)) {
      if (!ereg('([0-9]{1,2}).([0-9]{1,2}).([0-9]{1,2})', phpversion(), $regs)) {
         $result = ereg('([0-9]{1,2}).([0-9]{1,2})', phpversion(), $regs);
      }
      if (isset($regs) && !empty($regs[1])) {
         if (!isset($regs[2])) $regs[2] = 0;
         if (!isset($regs[3])) $regs[3] = 0;
         $php_version = (int) sprintf('%d%02d%02d', $regs[1], $regs[2], $regs[3]);
         unset($regs);
      } else $php_version = 0;
   }
   return $php_version;
}

function KWL_MakeGlobalVars() {
   $svar = array("G_PATH","G_URL","G_DB","G_HOST","G_PORT","G_USER","G_PASS","G_ENCODE");
   $var = array_merge($_GET,$_POST);
   if (count($var)) {
      foreach ($svar as $k) {
         if (array_key_exists($k, $var)) die("What are you doing?! ;-(");
      }
   import_request_variables("gp");
   }
}
?>
